<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>QualifiedNamesFromIJavaElementCollector xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/reverse/ui/utils/QualifiedNamesFromIJavaElementCollector.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2016 CEA LIST and others.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *   CEA LIST - Initial API and implementation</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *   </em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.utils;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.resources.IProject;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.IClassFile;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.ICompilationUnit;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.IJavaElement;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.IJavaProject;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.IPackageFragment;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.IPackageFragmentRoot;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.JavaCore;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jdt.core.JavaModelException;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelection;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.TreeSelection;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment"> * Utility class to collect the qualified name of Java units contains in the selection.</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment"> * @author cedric dumoulin</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/utils/QualifiedNamesFromIJavaElementCollector.html">QualifiedNamesFromIJavaElementCollector</a> {
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  	
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <em class="jxr_javadoccomment">	 * List of results.</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	<strong class="jxr_keyword">private</strong> List&lt;String&gt; result ;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 * True if and only if this list includes packages</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> includePackages = false;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 * True if and only if this list includes compilation units</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> includeCU = false;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  	
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment">	 * True if and only if this list includes class files (e.g. from jars)</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> includeClassFile = false;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 * Default Constructor.</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 * @param includePackages</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment">	 * @param includeCU</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/utils/QualifiedNamesFromIJavaElementCollector.html">QualifiedNamesFromIJavaElementCollector</a>() {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		<strong class="jxr_keyword">this</strong>(<strong class="jxr_keyword">true</strong>, <strong class="jxr_keyword">true</strong>, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  	}
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment">	 * Constructor.</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <em class="jxr_javadoccomment">	 * @param includePackages</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  <em class="jxr_javadoccomment">	 * @param includeCU</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/utils/QualifiedNamesFromIJavaElementCollector.html">QualifiedNamesFromIJavaElementCollector</a>(<strong class="jxr_keyword">boolean</strong> includePackages, <strong class="jxr_keyword">boolean</strong> includeCU, <strong class="jxr_keyword">boolean</strong> includeClassFiles) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  		<strong class="jxr_keyword">this</strong>.includePackages = includePackages;
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		<strong class="jxr_keyword">this</strong>.includeCU = includeCU;
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		<strong class="jxr_keyword">this</strong>.includeClassFile = includeClassFiles;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		<strong class="jxr_keyword">this</strong>.result = <strong class="jxr_keyword">new</strong> ArrayList&lt;String&gt;();
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  	}
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 * Collect the list of qualified names extracted from selection. </em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 * All Java classifiers found in the collection are collected.</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 * @param selection</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;String&gt; collectQualifiedNamesFromSelection( ISelection selection) {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/utils/QualifiedNamesFromIJavaElementCollector.html">QualifiedNamesFromIJavaElementCollector</a>().getQualifiedNamesFromSelection(selection);
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  	
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">	 * Collect the list of qualified names extracted from selection. </em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 * All Java classifiers found in the collection are collected.</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> <em class="jxr_javadoccomment">	 * @param selection</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 	<strong class="jxr_keyword">public</strong> List&lt;String&gt; getQualifiedNamesFromSelection( ISelection selection) {
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">if</strong>( selection instanceof TreeSelection) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			addFromTreeSelection( (TreeSelection)selection);
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		}
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		<strong class="jxr_keyword">return</strong> result;
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 	}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 	
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> <em class="jxr_javadoccomment">	 * @param selection</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> <em class="jxr_javadoccomment">	 * @param result </em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> <em class="jxr_javadoccomment">	 * @throws JavaModelException</em>
<a class="jxr_linenumber" name="L119" href="#L119">119</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> addFromTreeSelection(TreeSelection selection)  {
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		@SuppressWarnings(<span class="jxr_string">"unchecked"</span>)
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		Iterator&lt;Object&gt; selectionIterator = selection.iterator();
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		<strong class="jxr_keyword">while</strong> (selectionIterator.hasNext()) {
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			Object ele = selectionIterator.next();
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 			<strong class="jxr_keyword">if</strong>( ele instanceof IJavaElement) {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 				scanJavaElement((IJavaElement)ele);
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ele instanceof IProject) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 				IJavaProject javaProject = JavaCore.create((IProject) ele);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 				scanJavaElement(javaProject);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 			}
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 	}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L135" href="#L135">135</a> <em class="jxr_javadoccomment">	 * Add the specified item to the list of results.</em>
<a class="jxr_linenumber" name="L136" href="#L136">136</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> <em class="jxr_javadoccomment">	 * @param item</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> add(IJavaElement item) {
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_comment">//		String itemName = item.getElementName();</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_comment">//		if( item instanceof ICompilationUnit) {</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_comment">//			// This is the java filename. Need to remove the '.java'</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_comment">//			itemName = itemName.substring(0, itemName.length() - 5); // remove ".java" to the compilation unit name</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_comment">//		}</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		result.add(getQualifiedName(item));
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 	}
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 	<strong class="jxr_keyword">private</strong> String getQualifiedName( IJavaElement item) {
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		String res = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 		<strong class="jxr_keyword">switch</strong> (item.getElementType()) {
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.PACKAGE_FRAGMENT_ROOT:
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 			res = ((IPackageFragmentRoot) item).getElementName();
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.PACKAGE_FRAGMENT:
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 			res = ((IPackageFragment) item).getElementName();
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.COMPILATION_UNIT:
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 			<em class="jxr_comment">// Java class</em>
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 			res =  ((ICompilationUnit) item).findPrimaryType().getFullyQualifiedName('.');
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.CLASS_FILE:
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 			<em class="jxr_comment">// compiled class in Jar</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 			res = ((IClassFile) item).getType().getFullyQualifiedName('.');
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		}
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 		
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 		<strong class="jxr_keyword">return</strong> res;
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 	}
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> <em class="jxr_javadoccomment">	 * Scan a Compilation Unit item</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> <em class="jxr_javadoccomment">	 * Just add it if it's necessary</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> <em class="jxr_javadoccomment">	 * @param item</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_javadoccomment">	 *            a selection compilation unit</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> scanCU(ICompilationUnit item) {
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		<strong class="jxr_keyword">if</strong> (includeCU) {
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			add(item);
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 		}
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 	}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> <em class="jxr_javadoccomment">	 * Scan a Compilation Unit item</em>
<a class="jxr_linenumber" name="L186" href="#L186">186</a> <em class="jxr_javadoccomment">	 * Just add it if it's necessary</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> <em class="jxr_javadoccomment">	 * @param item</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> <em class="jxr_javadoccomment">	 *            a selection compilation unit</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> scanClassFile(IClassFile item) {
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 		<strong class="jxr_keyword">if</strong> (includeClassFile) {
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 			add(item);
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		}
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 	}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> <em class="jxr_javadoccomment">	 * Scan a package.</em>
<a class="jxr_linenumber" name="L199" href="#L199">199</a> <em class="jxr_javadoccomment">	 * add it if it's necessary and cross its childs to display all sub-packages (and recursively)</em>
<a class="jxr_linenumber" name="L200" href="#L200">200</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> <em class="jxr_javadoccomment">	 * @param item</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 *            the package to scan</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 * @param result </em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 * @throws JavaModelException</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> scanPackage(IPackageFragment item) {
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 		<strong class="jxr_keyword">if</strong> (includePackages) {
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 			add(item);
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 		}
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 		<em class="jxr_comment">// Recursive search in tree</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 			<strong class="jxr_keyword">for</strong> (IJavaElement child : item.getChildren()) {
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 				scanJavaElement(child);
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 			}
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 		} <strong class="jxr_keyword">catch</strong> (JavaModelException e) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 			<em class="jxr_comment">// Can't get children. Stop.</em>
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 		}
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 	}
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L222" href="#L222">222</a> <em class="jxr_javadoccomment">	 * Scan a source folder.</em>
<a class="jxr_linenumber" name="L223" href="#L223">223</a> <em class="jxr_javadoccomment">	 * add its childs (and recursively) by calling scanJavaElement on each child</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> <em class="jxr_javadoccomment">	 * @param item</em>
<a class="jxr_linenumber" name="L226" href="#L226">226</a> <em class="jxr_javadoccomment">	 *            the folder to scan</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> <em class="jxr_javadoccomment">	 * @param result </em>
<a class="jxr_linenumber" name="L228" href="#L228">228</a> <em class="jxr_javadoccomment">	 * @throws JavaModelException</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> scanFolder(IPackageFragmentRoot item)  {
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		<em class="jxr_comment">// Recursive search in tree</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 			<strong class="jxr_keyword">for</strong> (IJavaElement child : item.getChildren()) {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 				scanJavaElement(child);
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 			}
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 		} <strong class="jxr_keyword">catch</strong> (JavaModelException e) {
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 			<em class="jxr_comment">// Problem during scan of child. Skip.</em>
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		}
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 	}
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 	
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> <em class="jxr_javadoccomment">	 * Scan a source folder.</em>
<a class="jxr_linenumber" name="L243" href="#L243">243</a> <em class="jxr_javadoccomment">	 * add its childs (and recursively) by calling scanJavaElement on each child</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> <em class="jxr_javadoccomment">	 * @param item</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> <em class="jxr_javadoccomment">	 *            the folder to scan</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> <em class="jxr_javadoccomment">	 * @param result </em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> <em class="jxr_javadoccomment">	 * @throws JavaModelException</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> scanProject(IJavaProject item)  {
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 		<em class="jxr_comment">// Recursive search in tree</em>
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 			<strong class="jxr_keyword">for</strong> (IJavaElement child : item.getChildren()) {
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 				scanJavaElement(child);
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 			}
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 		} <strong class="jxr_keyword">catch</strong> (JavaModelException e) {
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 			<em class="jxr_comment">// Problem during scan of child. Skip.</em>
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 		}
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 	}
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L262" href="#L262">262</a> <em class="jxr_javadoccomment">	 * scan and add a JavaElement by delegates to scan{typeOfJavaElement}</em>
<a class="jxr_linenumber" name="L263" href="#L263">263</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L264" href="#L264">264</a> <em class="jxr_javadoccomment">	 * @param item</em>
<a class="jxr_linenumber" name="L265" href="#L265">265</a> <em class="jxr_javadoccomment">	 *            the item to display</em>
<a class="jxr_linenumber" name="L266" href="#L266">266</a> <em class="jxr_javadoccomment">	 * @param result </em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> <em class="jxr_javadoccomment">	 * @throws JavaModelException</em>
<a class="jxr_linenumber" name="L268" href="#L268">268</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> scanJavaElement(IJavaElement item) {
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 		<strong class="jxr_keyword">switch</strong> (item.getElementType()) {
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.PACKAGE_FRAGMENT_ROOT:
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 			scanFolder((IPackageFragmentRoot) item);
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.PACKAGE_FRAGMENT:
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 			scanPackage((IPackageFragment) item);
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.COMPILATION_UNIT:
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 			scanCU((ICompilationUnit) item);
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.CLASS_FILE:
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 			scanClassFile((IClassFile) item);
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 		<strong class="jxr_keyword">case</strong> IJavaElement.JAVA_PROJECT:
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 			scanProject((IJavaProject) item);
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 		}
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 	}
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 
<a class="jxr_linenumber" name="L288" href="#L288">288</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
